/**   
* @Title: IMManager.java 
* @Package com.hdp.customerservice 
* @Description: TODO
* @author new12304508_163_com   
* @date 2015年6月15日 下午2:59:46 
* @version V1.0   
*/
package com.hdp.customerservice.websocket;

import java.io.IOException;
import java.util.Iterator;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.LinkedBlockingQueue;

import javax.websocket.Session;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.util.StringUtils;

import com.alibaba.fastjson.JSONObject;
import com.hdp.customerservice.websocket.model.Customer;
import com.hdp.customerservice.websocket.model.Waiter;
import com.hdp.pi.wechat.model.BaseEntity;

public class IMManager {
	private static Log log=LogFactory.getLog(IMManager.class);
	
	public static ConcurrentHashMap<String,Waiter> 
					waiters = new ConcurrentHashMap<String, Waiter>();
	
	private static LinkedBlockingQueue<BaseEntity> queue=new LinkedBlockingQueue<BaseEntity>();
	
	public static void broadcast(String id,String message){
		Iterator<Waiter> ws= waiters.values().iterator();
		while(ws.hasNext()){
			try{
				Waiter w=(Waiter)ws.next();
				Session s=w.session;
				if(s!=null && s.isOpen() && w.id != id){
					s.getBasicRemote().sendText(message);
				}
			}catch(Throwable e){
			}
		}
	}
	
	public static void pushMessage(BaseEntity message){
		CustomerManager.addUserIfNotExist(message);
		try {
			queue.put(message);
		} catch (InterruptedException e) {
		}
	}
	
	static{//测试用0.0
		new Thread(new Runnable() {//消息发射器
			
			public void hand(){
				BaseEntity e=queue.poll();
				if(e == null){
					return ;
				}
				Customer customer=CustomerManager.getUserByOpenId(e.openId);
				if(customer == null){
					pushMessage(e);
					return;
				}
				
				Waiter waiter = WaiterManager.getWaiterById(customer.waiterId);
				if(waiter == null){
					pushMessage(e);
					return;
				}
				
				Session session= waiter.session;
				if(session == null || !session.isOpen()){
					pushMessage(e);
					return;
				}
				
				try {
					session.getBasicRemote().sendText(JSONObject.toJSONString(e));
				} catch (IOException e1) {
					pushMessage(e);
					return;
				}
			}
			
			@Override
			public void run() {
				while(true){
					hand();
					try {
						Thread.sleep(10);
					} catch (InterruptedException e) {
					}
				}
			}
		}).start();
		
		new Thread(new Runnable() {//分配客服
			
			public void hand(){
				Customer[] cs = CustomerManager.getUsers();
				Waiter[] ws=WaiterManager.getWaits();
				
				for (Customer c : cs) {
					if(!StringUtils.isEmpty(c.waiterId)){
						continue;
					}
					for(Waiter w : ws){
						if(w.customs.size() == 0){
							c.waiterId=w.id;
							w.customs.add(c.openId);
							continue;
						}
					}
				}
			}
			
			@Override
			public void run() {
				while(true){
					hand();
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
					}
				}
			}
		}).start();
	}
}
